#include <curses.h>
#include <stdarg.h>
#include "curses-util.h"

void
wfillx(WINDOW *window, int x)
{
	int c;
	for (c = getcurx(window); c < x; c++)
		waddch(window, ' ');
}

void
wfilly(WINDOW *window, int y)
{
	int c;
	for (c = getcury(window); c < y; c++) {
		waddch(window, ' ');
		wmove(window, c+1, getcurx(window));
	}
}

void
wfillyx(WINDOW *window, int y, int x)
{
	int c, d;
	int x0 = getcurx(window);
	
	for (c = getcury(window); c < y; c++) {
		for (d = x0; d < x; d++)
			waddch(window, ' ');
		wmove(window, c+1, x0);
	}
}

void
mvwfillx(WINDOW *window, int y0, int x0, int x)
{
	wmove(window, y0, x0);
	for (; x0 < x; x0++)
		waddch(window, ' ');
}

void
mvwfilly(WINDOW *window, int y0, int x0, int y)
{
	wmove(window, y0, x0);
	for (; y0 < y; y0++) {
		waddch(window, ' ');
		wmove(window, y0+1, x0);
	}
}

void
mvwfillyx(WINDOW *window, int y0, int x0, int y, int x)
{
	int d;

	wmove(window, y0, x0);
	for (; y0 < y; y0++) {
		for (d = x0; d < x; d++)
			waddch(window, ' ');
		wmove(window, y0+1, x0);
	}
}

int
wnprintw(WINDOW *win, int n, char *fmt, ...)
{
	int count;
	va_list ap;

	va_start(ap, fmt);
	count = vwnprintw(win, n, fmt, ap);
	va_end(ap);

	return count;
}

int
vwnprintw(WINDOW *win, int n, char *fmt, va_list ap)
{
	char buf[n+1];
	int count;

	count = vsnprintf(buf, n+1, fmt, ap);
	waddstr(win, buf);

	return count;
}

int
mvwnprintw(WINDOW *win, int y, int x, int n, char *fmt, ...)
{
	int count;
	va_list ap;

	va_start(ap, fmt);
	move(y, x);
	count = vwnprintw(win, n, fmt, ap);
	va_end(ap);

	return count;
}
