#ifndef CURSES_UTIL_H
#define CURSES_UTIL_H

#include <curses.h>
#include <stdarg.h>

#define fillx(x)			wfillx(stdscr,x)
#define filly(y)			wfilly(stdscr,y)
#define fillyx(y,x)			wfilly(stdscr,y,x)
#define mvfillx(y0,x0,x)	mvwfillx(stdscr,y0,x0,x)
#define mvfilly(y0,x0,y)	mvwfilly(stdscr,y0,x0,y)
#define mvfillyx(y0,x0,y,x)	mvwfilly(stdscr,y0,x0,y,x)

void wfillx(WINDOW *window, int x);
void wfilly(WINDOW *window, int y);
void wfillyx(WINDOW *window, int y, int x);
void mvwfillx(WINDOW *window, int y0, int x0, int x);
void mvwfilly(WINDOW *window, int y0, int x0, int y);
void mvwfillyx(WINDOW *window, int y0, int x0, int y, int x);

#define nprintw(n,fmt,...)			wnprintw(stdscr,n,fmt,__VA_ARGS__)
#define mvnprintw(y,x,n,fmt,...)	mvwnprintw(stdscr,y,x,n,fmt,__VA_ARGS__)

int wnprintw(WINDOW *win, int n, char *fmt, ...);
int mvwnprintw(WINDOW *win, int y, int x, int n, char *fmt, ...);
int vwnprintw(WINDOW *win, int n, char *fmt, va_list ap);

#endif
