#include <config.h>
#include <gtk/gtk.h>

static const char *about_message =
	"ConnMon " VERSION "\n"
	"\n"
	"Author: Oskar Liljeblad <oskar@osk.mine.nu>\n"
	"\n"
	"A connection and bandwidth monitoring program.";

void
show_about_dialog(void)
{
	GtkWidget *window;
	GtkWidget *box;
	GtkWidget *text;
	GtkWidget *buttonbox;
	GtkWidget *button;

	window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(window), "About");
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
	gtk_window_set_policy(GTK_WINDOW(window), FALSE, FALSE, FALSE);

	box = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(window), box);
	gtk_container_set_border_width(GTK_CONTAINER(box), 10);

	text = gtk_text_new(NULL, NULL);
	gtk_widget_set_usize(GTK_WIDGET(text), 270, 150);
	GTK_WIDGET_UNSET_FLAGS(text, GTK_CAN_FOCUS);
	gtk_box_pack_start(GTK_BOX(box), text, TRUE, TRUE, 0);
	gtk_text_set_editable(GTK_TEXT(text), FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(text), TRUE);
	gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, about_message, -1);

	gtk_box_pack_start(GTK_BOX(box), gtk_hseparator_new(), FALSE, TRUE, 5);

	buttonbox = gtk_hbutton_box_new();
	gtk_box_pack_start(GTK_BOX(box), buttonbox, FALSE, TRUE, 0);

	button = gtk_button_new_with_label("OK");
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), (gpointer) window);
	gtk_container_add(GTK_CONTAINER(buttonbox), button);
	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
	GTK_WIDGET_SET_FLAGS(button, GTK_HAS_DEFAULT);

	gtk_widget_show_all(window);
}
