#ifndef LIBCONNMON_INTERNAL_H
#define LIBCONNMON_INTERNAL_H

#include <config.h>
#include "common/common.h"
#include "common/hmap.h"
#include "common/llist.h"
#include "libconnmon.h"
#include "filter.h"

typedef struct _ConnMonPrivate ConnMonPrivate;
typedef struct _ConnMonDriver ConnMonDriver;
typedef struct _ConnTrackPrivate ConnTrackPrivate;

struct _ConnMonPrivate {
	ConnMon cm;
	ConnMonDriver *driver;
	LList *connection_unused;
	HMap *connections;
	Iterator *it;
	Expr *filter;
};

struct _ConnMonDriver {
	uint32_t struct_size;
	bool (*initialize)(ConnMonPrivate *cmp, const char *args);
	void (*free)(ConnMonPrivate *cmp);
	bool (*read_conns)(ConnMonPrivate *cmp, int64_t time);
}; 

struct _ConnTrackPrivate {
	ConnTrack ct;
};

/* libconnmon.c */
ConnTrack *cm_ct_lookup(ConnMonPrivate *cmp, ConnTuple *tuple, ConnStats *stats);
void cm_ct_report(ConnMonPrivate *cmp, ConnTrack *ct);

/* cm_netfilter.c */
extern ConnMonDriver netfilter_cm_driver;

/* cm_linux.c */
extern ConnMonDriver linux_cm_driver;

#endif
