#ifndef LIBHNL_INTERNAL_H
#define LIBHNL_INTERNAL_H

#include "common/hmap.h"
#include "libhnl.h"

typedef struct _HNLManagerPrivate HNLManagerPrivate;

struct _HNLManagerPrivate {
    HNLManager hm;
    HNLService **services;
    int service_count;
	bool caching;
	HMap *cache;
};

struct _HNLService {
    HNLManagerPrivate *hmp;
    void (*initialize)(HNLService *svc);
    void (*free)(HNLService *svc);
    void (*lookup)(HNLService *svc, HNLQuery *query);
    void (*cancel)(HNLService *svc, HNLQuery *query);
    void (*preselect)(HNLService *svc, SelectData *data);
    void (*postselect)(HNLService *svc, SelectData *data);
};

struct _HNLQuery {
    int current_service;
    uint32_t ip;
    char *answer;
    void *userdata;
	void *servicedata;
};

void hnl_lookup_finished(HNLManagerPrivate *hmp, HNLQuery *query);

#endif
