#ifndef LIBHNL_H
#define LIBHNL_H

#include <sys/types.h>
#include <sys/time.h>
#include <stdint.h>
#include "common/common.h"

typedef struct _HNLManager HNLManager;
typedef struct _HNLQuery HNLQuery;
typedef struct _HNLService HNLService;
typedef struct _SelectData SelectData;

struct _HNLManager {
    void (*lookup_finished)(HNLManager *hm, uint32_t ip, char *result, void *userdata);
};

struct _SelectData {
	int max_fd;
	fd_set read_fds;
	fd_set write_fds;
	fd_set except_fds;
	struct timeval timeout;
};

HNLManager *hnl_new(void);
bool hnl_initialize_from_spec(HNLManager *hm, const char *spec);
void hnl_set_caching(HNLManager *hm, bool caching);
void hnl_free(HNLManager *hm);
void hnl_add_service(HNLManager *hm, HNLService *svc);
HNLQuery *hnl_lookup(HNLManager *hm, uint32_t ip, void *userdata);
void hnl_cancel(HNLManager *hm, HNLQuery *query);
void hnl_preselect(HNLManager *hm, SelectData *data);
void hnl_postselect(HNLManager *hm, SelectData *data);
void hnl_clear_select_data(SelectData *sd);

#endif
