#ifndef LIBPNL_H
#define LIBPNL_H

#include <stdint.h>

enum {
	PNL_PROTO_IP	= 0,
	PNL_PROTO_ICMP	= 1,
	PNL_PROTO_TCP	= 6,
	PNL_PROTO_UDP	= 17,
};

typedef struct _PNLManager PNLManager;

PNLManager *pnl_new(void);
bool pnl_initialize_from_spec(PNLManager *pm, const char *spec);
const char *pnl_lookup(PNLManager *pm, uint16_t protocol, uint16_t port);
void pnl_free(PNLManager *pm);

#endif
